"{ Package: 'stx:libbasic2' }"

"{ NameSpace: Smalltalk }"

LimitedPrecisionReal variableByteSubclass:#IEEEFloat
	instanceVariableNames:'exponentSize'
	classVariableNames:''
	poolDictionaries:''
	category:'Magnitude-Numbers'
!

!IEEEFloat class methodsFor:'documentation'!

documentation
"
    Unfinished, ongoing work

    soft float emulation for arbitrary IEEE float formats.
    This is very very slow and should only be used when importing 
    funny sized floating point numbers (such as float24 or float8) from
    external sources, or to simulate computations on otherwise unsupported floating pnt numbers.
"
! !

!IEEEFloat class methodsFor:'instance creation'!

size:numBits exponentSize:exponentSize
    ^ (self basicNew:(numBits // 8)) exponentSize:exponentSize

    "
     self size:256 exponentSize:19
    "
!

size:numBits exponentSize:exponentSize fromFloat:aFloat
    ^ ((self basicNew:(numBits // 8)) exponentSize:exponentSize) setValueFromFloat:aFloat

    "
     self size:256 exponentSize:19 fromFloat:1.0
     self size:256 exponentSize:19 fromFloat:2.0
    "
!

size:numBits exponentSize:exponentSize fromInteger:anInteger
    ^ ((self basicNew:(numBits // 8)) exponentSize:exponentSize) setValueFromInteger:anInteger

    "
     self size:256 exponentSize:19 fromInteger:1
     self size:256 exponentSize:19 fromInteger:2
    "
! !

!IEEEFloat class methodsFor:'queries'!

isAbstract
    "Return if this class is an abstract class.
     True is returned here for myself only; false for subclasses.
     Abstract subclasses must redefine this again."

    ^ self == IEEEFloat.
! !

!IEEEFloat methodsFor:'accessing'!

exponentSize
    ^ exponentSize
!

exponentSize:something
    exponentSize := something.
!

setValueFromInteger:intValue
    "/ how many bits are there, in this int
    |absValue myNumBits numBitsInNumber shift|

    absValue := intValue abs. 
    numBitsInNumber := absValue highBit.
    myNumBits := (self basicSize * 8) - 1 "sign" - exponentSize.
    shift := myNumBits - numBitsInNumber. 
    numBitsInNumber > myNumBits ifTrue:[
        self halt.
    ] ifFalse:[
        "/ number:
        "/    1xxxxxxx...xxxxx
        "/ myRep:
        "/    seee...eeexxxxxxxxxx
        absValue digitLength to:1 by:-1 do:[:byteIndex |
            
        ].
    ].

    "/ cut off some bits

    "Float numBitsInExponent
     self size:16 exponentSize:4 fromInteger:1
     self size:32 exponentSize:11 fromInteger:1

     self size:256 exponentSize:19 fromInteger:1
     self size:256 exponentSize:19 fromInteger:2
    "
! !

!IEEEFloat class methodsFor:'documentation'!

version_CVS
    ^ '$Header$'
! !

